/*
 *	adc.c - A/Dϊ
 *
 *	* Wed Feb 06 19:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33208.h"

#define plc_IO ((volatile struct c_IOtag*)0x40000)	/* c33208.hp */
char vbuff[DISP_X * DISP_Y];				/* zVRAM */

#define CH_START	0	/* ϊJn`l */
#define CH_END		7	/* ϊI`l */

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	/* ʏ̏B */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

DISABLE;
	/* VXe̓drd菈𖳌܂B */
	pceTimerSetCallback(5, PCE_TT_NONE, 0, NULL);

	/* A/Dϊ~܂B
	 * A/Dϊ̐ݒύX́AK~ɍsȂ΂܂B
	 */
	bAD_EN_ADE = 0;

	/* K60`K67AAD0`AD7ƂĎgp܂B */
	pK6_CFK6 = 0xFF;

	/* A/Dϊ[hAʏ탂[hɐݒ肵܂B */
	bAD_TRIG_MS = 0;

	/* A/DϊJngKA\tgEFAɐݒ肵܂B */
	bAD_TRIG_TS = 0;

	/* * A/Dϊ̓̓NbNݒ肵AvXP[N܂B
	 *	24MHz / 16 = 1.5MHz
	 *   A/Dϊ̓̓NbŃA2MHzȉłȂ΂܂B
	 * * A/Dϊ̓̓NbNxقǁAmȑlƂȂ悤łB
	 *   ̓NbN𑁂ƁA`l̑茋ʂÃ`lɉe^܂B
	 *   Ⴆ1.5MHz̏ꍇACh.3̓͂0.0VACh.4̓͂3.3VƂƁA
	 *   Ch.4̑茋ʂCh.3ɈāA2.9V炢ɂȂĂ܂悤łB
	 *   ͂93KHz(24MHz/256)ő肷ƁACh.4͂قƂǂЂς܂B
	 */
	bCLKCTL_AD_PSAD = 3;
	bCLKCTL_AD_PSONAD = 1;

	/* ̓TvOԂA9NbNɐݒ肵܂B
	 * 9NbNȊO̒lɐݒ肵Ă͂܂B
	 */
	bAD_SMPL_ST = 3;

	/* ϊJnEI`lݒ肵܂B */
	bAD_CHNL_CS = CH_START;
	bAD_CHNL_CE = CH_END;

	/* A/Dϊ荞݂֎~AmɊ荞ݗvNA܂B */
	bINT_EP47_ECT_EAD_EADE = 0;
	bINT_FP47_FCT_FAD_FADE = 0;

	/* A/DϊLɂ܂B */
	bAD_EN_ADE = 1;
ENABLE;
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
DISABLE;
	/* ZbgxN^փWv܂B */
	asm("
		xld.w	%r4, 0xC00000
		jp	%r4
	");
ENABLE;
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	int i, n;
	int v[8];	/* `l0`7̑l */
	int w[8];	/* e`l芮̃`lXe[^X */


	/* 3bASi-Did̂߂ɁAP00ONɂ܂B */
	if(count == 30) bP0_P0D_P00D = 1;

	memset(v, 0, sizeof v);
	memset(w, 0, sizeof w);
DISABLE;
	/* Ô߁AmA/Dϊ~܂B */
	ADST_STOP;

	/* A/DϊJn܂B */
	ADST_RUN;

	i = 0;
	do {
		/* ݂̃`l̕ϊI҂܂B */
		while(!bAD_EN_ADF) ;

		/* li[܂B */
		v[CH_START + i & 7] = pAD_ADD;

		/* `lXe[^Xi[܂B */
		w[CH_START + i & 7] = bAD_TRIG_CH;

		i++;
	} while(bAD_EN_ADST); /* ŏI`l̕ϊH */
ENABLE;

	/* 茋ʂ\܂B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x80);
	for(i = 0; i < 8; i++) {
		pceFontSetPos(0, i * 10);
		n = 330 * v[i] + 512 >> 10;
		pceFontPrintf("Ch.%d %1d.%02d[V], next Ch.%d",
			i, n / 100, n % 100, w[i]);
	}
	pceLCDTrans();
}
